#include <RH_ASK.h>
#include <SPI.h>
#include <MFRC522.h>

#define RST_PIN         9          
#define SS_PIN          10         
#define BUTTON_PIN      7         
#define D4              4          
#define D5              5          

RH_ASK rf_driver(2000, 8);         
MFRC522 mfrc522(SS_PIN, RST_PIN);  

void setup() {
    Serial.begin(9600);             
    if (!rf_driver.init()) {      
        Serial.println("RF module initialization failed");
        while (1);                 
    }

    SPI.begin();                  
    mfrc522.PCD_Init();             

    pinMode(BUTTON_PIN, INPUT_PULLUP); 
    pinMode(D4, OUTPUT);            
    pinMode(D5, OUTPUT);            

    
    digitalWrite(D4, HIGH);
    digitalWrite(D5, HIGH);
}

void loop() {
    
    if (digitalRead(BUTTON_PIN) == LOW) {  
        digitalWrite(D4, LOW);             
        digitalWrite(D5, LOW);           
    } else {
        
        uint8_t buf[12];                  
        uint8_t buflen = sizeof(buf);

        
        if (rf_driver.recv(buf, &buflen)) {
            buf[buflen] = '\0';          
            Serial.print("Message: ");
            Serial.println((char*)buf);

            
            digitalWrite(D4, LOW);     
        } else {
            digitalWrite(D4, HIGH);      
        }

       
        if (mfrc522.PICC_IsNewCardPresent() && mfrc522.PICC_ReadCardSerial()) {
            Serial.println("RFID_Detected"); 
            digitalWrite(D5, LOW);          
        } else {
            digitalWrite(D5, HIGH);         
        }
    }
}
